module det_airy_types
use ireg_airy_types

implicit none

!-----------------------------------------------
Type Tdet_airy
  character*1024                        :: file = ""     ! input file name for deterministic time series of wave elevation
  integer                               :: dformat = 0   ! data format of time series in input file (0=ascii, 1=single, 2=double)
  integer                               :: nsamples = 0  ! NOF lines to be read from input file
  integer                               :: nskip  = 0    ! NOF lines to skip before starting to read time series
  integer                               :: col_time = 1  ! Column number in file where time is located
  integer                               :: col_elev = 2  ! Column number in file where wave elevation is located
!  double precision, pointer             :: elev(:)       ! Wave elevation time series read from file
!  double precision                      :: h = 0.d0      ! Time step between wave elevation samples (= (t1-t0)/(nsamples-1))
  double precision                      :: T = 0.d0      ! Period of time series 
  double precision                      :: cutoff_frac = 1.d-5 ! Fraction of total energy which is discarded in the low and the high frequency range
!
  type (Tireg)                          :: ireg          ! Irregular wave data (amplitudes, frequencies, etc.)
end type Tdet_airy

end module det_airy_types