Module genout_typesnvars
implicit none

! Global constans
integer maxwords
integer maxsensors
parameter(maxwords = 25)       
parameter(maxsensors = 500)    ! max number of outputsensors, when changes format specifier in write_hawc_dat_file subroutine 
                               ! in genout_tools needs to be changed as well
integer wordlenght
parameter(wordlenght=64)

!--------------------------------------------------------------------
! Type declarations
!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Tmasterfile
  character*100					:: name
  integer						:: unit, &
								   linenr=0              ! last read line number
!
  Type (Tmasterfile),pointer	:: child
  Type (Tmasterfile),pointer	:: mother
  integer						:: level=0
end type Tmasterfile

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Tline
  character*512 :: line 
end type Tline

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Tword
  character*wordlenght,dimension(maxwords) :: word_vec
  integer :: nwords
end type Tword

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Toutvar
  character*512  :: string1=''            ! when lenght is changed output format of .sel file must be changed as well
  character*30  :: string2=''
  character*10  :: string3=''
  real*8        :: out
end type Toutvar

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Toutput_sensor
  integer										:: output_number=0		! number in output order
  character*wordlenght, dimension(maxwords)		:: str					! command word
  real*8,dimension(maxwords)					:: rea					! real parameters
  character*256									:: label=''				! small label a user could add to the sensor describtion
  logical										:: only_exclude=.false. ! "true" if this sensor is excluded by only command
end type Toutput_sensor

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Toutput         ! NB instead of used fixed array sizes with maxsensors,maxwords more dynamic allocation would really reduce .exe size
!  Type (Toutput_sensor),dimension(maxsensors)	  :: sensor
  Type (Toutput_sensor),dimension(:),pointer	  :: sensor=>null()
  integer                                         :: nsensors=0 ! number of sensors defined
  integer										  :: nout		! number of output sensors used
  character*wordlenght                            :: filename   ='default'
  character*wordlenght                            :: data_format='hawc_ascii'  ! output_type
  integer                                         :: start_step=1 ! start step number for output
  integer                                         :: stop_step    ! stop step number for output
  Type (T_HFoutput),pointer                       :: HF           ! information used with the HAWC format write out
  Type (T_HFBoutput),pointer                      :: HFB          ! information used with the compressed HAWC binary format write out
  ! Next, only used for output_at_time writeout
  real*8                                          :: time       ! time for output writing (only used for output_at_time)
  character*wordlenght                            :: command    ! command word (only used for output_at_time)
  ! Next only used for DLL outputs
  integer                                         :: nov=0      ! size of ov
  Type (Toutvar),dimension(:),pointer             :: ov         ! vector containing output data specified by DLL control format
end Type Toutput

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Toutputs
  integer                                         :: nout=0     ! number of output sets
  Type (Toutput),dimension(:),pointer             :: output     ! Output information
end Type Toutputs

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Toutput_buffer
  integer                             :: bufsteps=3000        ! Definition of buffer size
  real*4,dimension(:,:),pointer       :: dat
  integer                             :: buf_step
end type Toutput_buffer

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type T_HFoutput                               ! variables for original HAWC ascii format
  Type (Toutput_buffer)   :: obuf
  integer                 :: sel_unitnr       ! Unit number for sel file
  logical                 :: sel_status       ! true=open, false=closed
  character*1024,dimension(:),pointer :: sel_buf
  integer :: nout=0

  logical :: init=.true.
  integer :: dat_unitnr
end Type T_HFoutput

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type T_HFBoutput                              ! variable for compressed HAWC binary format
  Type (Toutput_buffer)   :: obuf             ! buffer for output - must be big enough to contain all data
  integer                 :: sel_unitnr       ! Unit number for sel file
  logical                 :: sel_status       ! true=open, false=closed
  character*1024,dimension(:),pointer :: sel_buf    
  real*8,dimension(:),pointer  :: factor           ! scale factors for sensors to compressed HAWC binary format
  integer :: nout=0

  logical :: init=.true.
  integer :: dat_unitnr
end Type T_HFBoutput

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Toutput_at
  integer :: nout=0
  Type (Toutput),dimension(:),pointer :: out
end Type Toutput_at

!--------------------------------------------------------------------
!--------------------------------------------------------------------

Type Toutvar_at
  character*256 :: filename                          ! sammen definition som i typen Toutput
  integer       :: nsensors
  character*75, dimension(:),pointer  :: string
  real*8,dimension(:,:),pointer  :: dat   
end type Toutvar_at

!--------------------------------------------------------------------
!--------------------------------------------------------------------
Type (Toutput_at),public,save:: gloutput_at

end module