module global_typesnvars
use ireg_airy_types
use reg_airy_types
use det_airy_types
use stream_func_types
use wavemods_types

implicit none


!-----------------------------------------------
Type Twdata
  real*8				:: time		=0.d0       ! time requested from outside call
  real*8,dimension(3,3) :: tgh	! transformation matrix from global to hydro coo
  real*8,dimension(3,3) :: thg	! transformation matrix from hydro to global coo
  real*8				:: wdepth	! water depth
  real*8				:: g		=9.81	! gravity acc.
  real*8				:: rho		=1050.d0 ! density of water kg/m^3
  integer				:: wavetype	=1		! 0=reg airy, 1=ireg airy, 2=det airy
  Type (Tireg),pointer			:: ireg		! iregular airy data
  Type (Treg),pointer			:: reg		! regular airy data
  Type (Tdet_airy),pointer		:: det		! deterministic airy data
  Type (Tstrf),pointer			:: strf		! stream function data
  Type (Twavemods),pointer		:: wavemods	! wavemods function data
end type Twdata
!
!-----------------------------------------------
Type Tglobal
  real*8 :: time
end type Tglobal
!
!-----------------------------------------------
!-----------------------------------------------

Type (Tglobal),save :: global
Type (Twdata),save :: wd
Type (Tireg),save	:: ireg
real*8 :: pi


end module global_typesnvars