Module master_input
use genout_typesnvars
use genout_tools2
use genout_tools

implicit none

!--------------------------------------------------------------------
!--------------------------------------------------------------------
! Public/private declarations

public :: read_inputfile

contains

!--------------------------------------------------------------------
!--------------------------------------------------------------------

subroutine read_inputfile(filename)
use dfport
use wkin_input

character*(*) filename

Type (Tmasterfile),pointer :: masterfile

Type (Tline) :: line
logical,save :: eof                                ! End Of File
               
Type (Tword) :: words
logical                    :: init

integer :: error, info_array(12)

!call getarg(1,masterfile%name)                     ! filename from HAWC2 command parameter retrieved
allocate(masterfile)
masterfile%name = filename
call getfreeunit(masterfile%unit)           

error=stat(masterfile%name,info_array)
if (error/=0) then
  GOTO 10
else 
  open (unit=masterfile%unit, file=masterfile%name,err=10)  ! commandfile is opened
endif

init=.true.
eof=.false.
do while (eof==.false.)
    call readline(masterfile,line,init)          ! line is read
    call getwords(line%line,words,masterfile)                 ! words in line is retrieved
    if (words%word_vec(1)=='begin') then                   
      select case (trim(words%word_vec(2)))

        case ('wkin_input')                              ! aerodynamic input
          call wkininput(masterfile)

        case ('')
          continue

        case default
          write(0,*) '*** ERROR *** Error in command line ',masterfile%linenr,' Masterfile name: ',trim(masterfile%name)
      end select

    else if (words%word_vec(1)=='') then
      continue
    else if (words%word_vec(1)=='exit') then       ! End of file
      eof=.true.
      exit
    else
      write(0,*) 'Command line ignored. Line number: ',masterfile%linenr,' Masterfile name: ',trim(masterfile%name)
    endif
enddo

close (unit=masterfile%unit)

return
10 write(*,*) 'Error opening file: ',trim(masterfile%name)
stop
end subroutine read_inputfile

!--------------------------------------------------------------------
!--------------------------------------------------------------------


end module master_input
