module wavemods_types

implicit none

!-----------------------------------------------
Type Twavemods
  integer       :: Nd=0                 ! n.o. disrete depths in datafile 
  integer       :: Nt=0                 ! n.o. disrete times in datafile 
  integer		:: Ndum1
  integer		:: Ndum2
!  integer		:: N1
!  integer		:: N2
  real*8        :: filet0=0.0d0           ! t=0 in hawc2 corresponds to filetimestart in dll 
  real*8        ::	dummy	 =0.d0		! dummy-variable used ???
  real*8        ::	zmin                ! minimum z-value for evaluation of wave kinematics (i.e. mud level distance from mean surface level)
  character*128 :: datafile1             ! datafile with e.g. ascii data
  character*150 :: datafile2             ! datafile with e.g. ascii data
  real*8, dimension(:,:), allocatable :: z
  real*8, dimension(:,:), allocatable :: u
  real*8, dimension(:,:), allocatable :: w
  real*8, dimension(:,:), allocatable :: d2u_dz2
  real*8, dimension(:,:), allocatable :: a
  real*8, dimension(:,:), allocatable :: aw
  real*8, dimension(:,:), allocatable :: d2a_dz2
  real*8, dimension(:),   allocatable :: t
  real*8        :: tmax
  real*8, dimension(:),   allocatable :: eta
  real*8, dimension(:),   allocatable :: d2eta_dt2
end type Twavemods

end module wavemods_types