module wkin_input

implicit none

public :: wkininput

contains

Subroutine wkininput(masterfile)
use ireg_airy
use reg_airy
use det_airy
use stream_func
use genout_tools
!use global_vars
use global_typesnvars, only : wd
use wavemods

Type (Tmasterfile), pointer :: masterfile

Type (Tline) :: line
Type (Tword) :: words

real*8, dimension(maxwords) :: rea

logical :: init, &
           out, &
           err, &
           all_ok, &
		   wavetype_control, &
		   wdepth_control

init=.false.
out=.false.
wavetype_control=.false.
wdepth_control=.false.

do while (out==.false.)
  call readline(masterfile,line,init)        ! line is read
    call getwords(line%line,words,masterfile)                           ! words in line is retrieved
    select case (trim(words%word_vec(1)))

    case ('wavetype')
      call get_parameters(words,2,1,rea,err)
      if (err==.true.) then; goto 10; endif
      wd%wavetype=nint(rea(1))
      wavetype_control=.true.

	case ('wdepth')
      call get_parameters(words,2,1,rea,err)
      if (err==.true.) then; goto 10; endif
      wd%wdepth=rea(1)
      wdepth_control=.true.

!   -------------------------------------------
    case ('begin')
      select case (trim(words%word_vec(2)))
      
      case ('reg_airy')
	    allocate(wd%reg)
        call reg_airy_input(masterfile,wd%reg)                        ! input for ireg airy waves
      case ('ireg_airy')
	    allocate(wd%ireg)
        call ireg_airy_input(masterfile,wd%ireg)                      ! input for ireg airy waves
      case ('det_airy')
	    allocate(wd%det)
        call det_airy_input(masterfile,wd%det)                      ! input for ireg airy waves
      case ('strf')
	    allocate(wd%strf)
        call stream_func_input(masterfile,wd%strf)                        ! input for stream function wave
	  case ('wavemods')
		allocate(wd%wavemods)
		call wavemods_input(masterfile,wd%wavemods)                        ! input for user defined wave
      case default
        write(0,*) '*** ERROR *** Error in command line ',masterfile%linenr,' Masterfile name: ',trim(masterfile%name)
      end select

    case ('')
      continue

    case ('end')
      out=.true.
      ! Control of data given above is OK
      all_ok=.true.
      if ((wavetype_control==.false.) .or. &
	      (wdepth_control==.false.)) then
        all_ok=.false.
      endif
      if (all_ok==.true.) then
        write(0,*) 'Wkin dll input commands read with succes'
      else
        write(0,*) '*** ERROR *** Not all needed wkin_dll input commands present - error'
      endif

    case (';')
      continue
    case default
      write(0,*) '*** ERROR *** Error in command line ',masterfile%linenr,' Masterfile name: ',trim(masterfile%name)
    end select
enddo
return
10  write(0,*) '*** ERROR *** Error in command line ',masterfile%linenr,' Masterfile name: ',trim(masterfile%name)

end subroutine wkininput


end module wkin_input